# Method: projects.locations.files.annotate

- [HTTP request](https://docs.cloud.google.com/vision/product-search/docs/reference/rest/v1/projects.locations.files/annotate#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/vision/product-search/docs/reference/rest/v1/projects.locations.files/annotate#body.PATH_PARAMETERS)
- [Request body](https://docs.cloud.google.com/vision/product-search/docs/reference/rest/v1/projects.locations.files/annotate#body.request_body)
  - [JSON representation](https://docs.cloud.google.com/vision/product-search/docs/reference/rest/v1/projects.locations.files/annotate#body.request_body.SCHEMA_REPRESENTATION)
- [Response body](https://docs.cloud.google.com/vision/product-search/docs/reference/rest/v1/projects.locations.files/annotate#body.response_body)
- [Authorization Scopes](https://docs.cloud.google.com/vision/product-search/docs/reference/rest/v1/projects.locations.files/annotate#body.aspect)

Service that performs image detection and annotation for a batch of files. Now only "application/pdf", "image/tiff" and "image/gif" are supported.

This service will extract at most 5 (customers can specify which 5 in AnnotateFileRequest.pages) frames (gif) or pages (pdf or tiff) from each file provided and perform detection and annotation for each image extracted.

### HTTP request

`POST https://vision.googleapis.com/v1/{parent=projects/*/locations/*}/files:annotate`

The URL uses [gRPC Transcoding](https://github.com/googleapis/googleapis/blob/master/google/api/http.proto) syntax.

### Path parameters

| Parameters ||
|---|---|
| `parent` | `string` Optional. Target project and location to make a call. Format: `projects/{project-id}/locations/{location-id}`. If no parent is specified, a region will be chosen automatically. Supported location-ids: `us`: USA country only, `asia`: East asia areas, like Japan, Taiwan, `eu`: The European Union. Example: `projects/project-A/locations/eu`. <br /> |

### Request body

The request body contains data with the following structure:

| JSON representation ||
|---|---|
| ``` { "requests": [ { object (`https://docs.cloud.google.com/vision/product-search/docs/reference/rest/v1/AnnotateFileRequest`) } ] } ``` |

| Fields ||
|---|---|
| `requests[]` | ``object (`https://docs.cloud.google.com/vision/product-search/docs/reference/rest/v1/AnnotateFileRequest`)`` Required. The list of file annotation requests. Right now we support only one AnnotateFileRequest in BatchAnnotateFilesRequest. |

### Response body

If successful, the response body contains an instance of `https://docs.cloud.google.com/vision/product-search/docs/reference/rest/v1/BatchAnnotateFilesResponse`.

### Authorization Scopes

Requires one of the following OAuth scopes:

- `https://www.googleapis.com/auth/cloud-platform`
- `https://www.googleapis.com/auth/cloud-vision`

For more information, see the [Authentication Overview](https://cloud.google.com/docs/authentication/).